//===========================================================
// SAVEIT.H -- Header File 
//
// Copyright (C) 1995 Ziff-Davis Publishing Company
// First published in PC Magazine by Douglas Boling
//===========================================================
// Returns no. of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))   

#define  MAXMENULEN        40
#define  MAXCMDLINELEN     256
#define  MAXENTRIES        32

//-----------------------------------------------------------
// Generic defines and data types
//-----------------------------------------------------------
#define INT       int
#define APIENTRY  PASCAL

#define MYMSG_LAUNCHIT    WM_USER+20
//
// Structures used to parse the Program Manager's group files
//
typedef struct {
    char  cIdentifier[4];
    WORD  wCheckSum;
    WORD  cbGroup;
    WORD  nCmdShow;
    RECT  rcNormal;
    POINT ptMin;
    WORD  pName;
    WORD  wLogPixelsX;
    WORD  wLogPixelsY;
    BYTE  bBitsPerPixel;
    BYTE  bPlanes;
    WORD  Reserved;
    WORD  cItems;
    WORD  rgiItems[];
} GROUPHEADER;
typedef GROUPHEADER far * LPGROUPHEADER;

typedef struct {
    POINT pt;
    WORD  iIcon;
    WORD  cbResource;
    WORD  cbANDPlane;
    WORD  cbXORPlane;
    WORD  pHeader;
    WORD  pANDPlane;
    WORD  pXORPlane;
    WORD  pName;
    WORD  pCommand;
    WORD  pIconPath;
} ITEMDATA;
typedef ITEMDATA far *LPITEMDATA;

typedef struct {
    WORD wID;           // Specifies the type of data in the structure
    WORD wItem;         // Specifies what program item the tag refers.
    WORD cb;            // Specifies the size of the tag data
    BYTE rgb[1];        // Start of data for this tag
} TAGDATA;
typedef TAGDATA far *LPTAGDATA;

//
// Error numbers
//
#define ERR_LAUNCH        16


struct decodeUINT {                         // structure associates
    UINT Code;                              // messages 
    LONG (*Fxn)(HWND, UINT, UINT, LONG);    // with a function
}; 
struct decodeCMD {                          // structure associates
    UINT Code;                              // menu IDs with a 
    LONG (*Fxn)(HWND, UINT, HWND, UINT);    // function
};
//
// Program entry foramt
//
typedef struct {
	HTASK	hTask;
	UINT	fFlags;
	char	szName[128];
	char	szParms[128];
	char	szDir[128];
} PROGENTRY;
typedef PROGENTRY *PPROGENTRY;
//
// Function prototypes used by generic template
//
INT  APIENTRY WinMain(HINSTANCE, HINSTANCE, LPSTR, INT);
LONG CALLBACK MainWndProc(HWND, UINT, UINT, LONG);

INT  InitApp(HANDLE);
INT  InitInstance(HANDLE, LPSTR, INT);
INT  TermInstance(HANDLE, INT);
void PrintError (HWND, INT);
BOOL MyWritePrivateProfileInt (char *, char *, int, char *);
//
// Program specific prototypes
//
// Dialog box functions
BOOL CALLBACK AddDlgProc (HWND, UINT, UINT, LONG);
// Message handler functions
LONG DoPaintMain (HWND, UINT, UINT, LONG);
LONG DoCtlColorMain (HWND, UINT, UINT, LONG);
LONG DoLaunchItMain (HWND, UINT, UINT, LONG);
LONG DoEndSessionMain (HWND, UINT, UINT, LONG);
LONG DoQueryEndSessionMain (HWND, UINT, UINT, LONG);
LONG DoCloseMain (HWND, UINT, UINT, LONG);
LONG DoDestroyMain (HWND, UINT, UINT, LONG);
LONG DoCommandMain (HWND, UINT, UINT, LONG);
// Control function Prototypes
LONG DoMainCtlExit (HWND, UINT, HWND, UINT);

//Undocumented function prototypes
BOOL WINAPI IsWinOldApTask(HTASK);

void SavetoINI (void);
INT GetProgList (void);
INT ParseProgList (HGLOBAL);
HGLOBAL GetStartupInfo (void);
INT ChkInstalled (void);
INT InstallProg (BOOL);
//
// Profile String Names
//
#define     PRO_XPOS      "WinPosX"
#define     PRO_YPOS      "WinPosY"

#define     PRO_STATUS    "Status"
#define     PRO_CNT       "ArrayCnt"
#define     PRO_PARMS     "Parms"
#define     PRO_FLAGS     "Flags"
#define     PRO_CMD       "Cmd"
#define     PRO_DIR       "Dir"
//
// Resource Idendifiers
//
#define     IDD_EXIT       101
#define     IDD_PROGSTR    102
#define     IDD_FRAME      103
